#include <bits/stdc++.h>
#define MOD 998244353
using namespace std;

long long n,m,a[10005],c,b[10005],cp=1,res=0;

int main()
{
    ios::sync_with_stdio(false);
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        cin>>b[i];
    }
    for(int i=1;i<=n;i++)
    {
        a[i]=i;
    }
    for(int i=0;i<n-m+1;i++)
    {
        for(int j=1;j<=m;j++)
        {
            a[i+b[j]]=a[i+j];
        }
    }
    cin>>c;
    for(int i=1;i<=n;i++)
    {
        cp*=c;
        cp%=MOD;
        res+=cp*a[i]%MOD;
        res%=MOD;
    }
    cout<<res;
}